/* ***********************************************************
 * This file was automatically generated on 2012-09-26.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling up to 4 optically coupled digital inputs
	/// </summary>
	public class BrickletIndustrialDigitalIn4 : Device 
	{
		private static byte FUNCTION_GET_VALUE = 1;
		private static byte FUNCTION_SET_GROUP = 2;
		private static byte FUNCTION_GET_GROUP = 3;
		private static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = 4;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 5;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 6;
		private static byte FUNCTION_SET_INTERRUPT = 7;
		private static byte FUNCTION_GET_INTERRUPT = 8;
		private static byte CALLBACK_INTERRUPT = 9;


		/// <summary>
		///  This callback is triggered whenever a change of the voltage level is detected
		///  on pins where the interrupt was activated with <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetInterrupt"/>.
		///  
		///  The values are a bitmask that specifies which interrupts occurred
		///  and the current value bitmask.
		///  
		///  For example:
		///  
		///  * (1, 1) means that an interrupt on pin 0 occurred and
		///    currently pin 0 is high and pins 1-3 are low.
		///  * (9, 14) means that interrupts on pins 0 and 3
		///    occurred and currently pin 0 is low and pins 1-3 are high.
		/// </summary>
		public delegate void Interrupt(ushort interruptMask, ushort valueMask);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletIndustrialDigitalIn4(string uid) : base(uid) 
		{
			this.expectedName = "Industrial Digital In 4 Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_INTERRUPT] = new MessageCallback(CallbackInterrupt);
		}

		/// <summary>
		///  Returns the input value with a bitmask. The bitmask
		///  is 16 bit long, *true* refers to high and *false* refers to 
		///  low.
		///  
		///  For example: The value 0b0000000000000011 means that pins 0-1 
		///  are high and the other pins are low.
		///  
		///  If no groups are used (see <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>), the pins correspond to the
		///  markings on the Digital In 4 Bricklet.
		///  
		///  If groups are used, the pins correspond to the element in the group.
		///  Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
		///  pins 8-11 and element 4 pins 12-15.
		/// </summary>
		public ushort GetValue()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VALUE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets a group of Digital In 4 Bricklets that should work together. You can
		///  find Bricklets that can be grouped together with <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.GetAvailableForGroup"/>.
		///  
		///  The group consists of 4 elements. Element 1 in the group will get pins 0-3,
		///  element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
		///  
		///  Each element can either be one of the ports ('a' to 'd') or 'n' if it should
		///  not be used.
		///  
		///  For example: If you have two Digital In 4 Bricklets connected to port A and
		///  port B respectively, you could call with "['a', 'b', 'n', 'n']".
		///  
		///  Now the pins on the Digital In 4 on port A are assigned to 0-3 and the
		///  pins on the Digital In 4 on port B are assigned to 4-7. It is now possible
		///  to call <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.GetValue"/> and read out two Bricklets at the same time.
		/// </summary>
		public void SetGroup(char[] group)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_GROUP, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(group, 4, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the group as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>
		/// </summary>
		public char[] GetGroup()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_GROUP, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_GROUP, out response);

			return LEConverter.CharArrayFrom(4, response, 4);
		}

		/// <summary>
		///  Returns a bitmask of ports that are available for grouping. For example the
		///  value 0b0101 means: Port *A* and Port *C* are connected to Bricklets that
		///  can be grouped together.
		/// </summary>
		public byte GetAvailableForGroup()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_AVAILABLE_FOR_GROUP, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_AVAILABLE_FOR_GROUP, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Sets the debounce period of the <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.Interrupt"/> callback in ms.
		///  
		///  For example: If you set this value to 100, you will get the interrupt
		///  maximal every 100ms. This is necessary if something that bounces is
		///  connected to the Digital In 4 Bricklet, such as a button.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the pins on which an interrupt is activated with a bitmask.
		///  Interrupts are triggered on changes of the voltage level of the pin,
		///  i.e. changes from high to low and low to high.
		///  
		///  For example: An interrupt bitmask of 9 (0b0000000000001001) will 
		///  enable the interrupt for pins 0 and 3.
		///  
		///  The interrupts use the grouping as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetGroup"/>.
		///  
		///  The interrupt is delivered with the callback <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.Interrupt"/>.
		/// </summary>
		public void SetInterrupt(ushort interruptMask)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_INTERRUPT, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(interruptMask, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the interrupt bitmask as set by <see cref="Tinkerforge.BrickletIndustrialDigitalIn4.SetInterrupt"/>.
		/// </summary>
		public ushort GetInterrupt()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_INTERRUPT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_INTERRUPT, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetValue(out ushort valueMask)
		{
			valueMask = GetValue();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetGroup(out char[] group)
		{
			group = GetGroup();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAvailableForGroup(out byte available)
		{
			available = GetAvailableForGroup();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetInterrupt(out ushort interruptMask)
		{
			interruptMask = GetInterrupt();
		}

		internal int CallbackInterrupt(byte[] data_)
		{
			ushort interruptMask = LEConverter.UShortFrom(4, data_);
			ushort valueMask = LEConverter.UShortFrom(6, data_);

			((Interrupt)callbacks[CALLBACK_INTERRUPT])(interruptMask, valueMask);
			return 8;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Interrupt))
			{
				callbacks[CALLBACK_INTERRUPT] = d;
			}
		}
	}
}
